/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.recaudacion;

import com.rjconsultores.ventaboletos.entidad.TarjetaRecaudacion;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderDeducciones;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderDescripcionViajes;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPercepciones;
import java.util.List;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Label;
import org.zkoss.zul.Messagebox;

/**
 *
 * @author Administrador
 */
@Controller("pagarTarjetasViajesController")
@Scope("prototype")
public class PagarTarjetasViajesController extends MyGenericForwardComposer {

    private List<TarjetaRecaudacion> lsTarjetaRecaudacion;
    private MyListbox descripcionViajesList;
    private MyListbox percepcionesList;
    private MyListbox deduccionesList;
    private Label lblNombreClaveConductor;
    private Label lblTotalPercepciones1;
    private Label lblTotalPercepciones2;
    private Label lblTotalDeducciones1;
    private Label lblTotalDeducciones2;
    private Label lblNetoPagar;

    public MyListbox getDeduccionesList() {
        return deduccionesList;
    }

    public void setDeduccionesList(MyListbox deduccionesList) {
        this.deduccionesList = deduccionesList;
    }

    public MyListbox getDescripcionViajesList() {
        return descripcionViajesList;
    }

    public void setDescripcionViajesList(MyListbox descripcionViajesList) {
        this.descripcionViajesList = descripcionViajesList;
    }

    public Label getLblNetoPagar() {
        return lblNetoPagar;
    }

    public void setLblNetoPagar(Label lblNetoPagar) {
        this.lblNetoPagar = lblNetoPagar;
    }

    public Label getLblNombreClaveConductor() {
        return lblNombreClaveConductor;
    }

    public void setLblNombreClaveConductor(Label lblNombreClaveConductor) {
        this.lblNombreClaveConductor = lblNombreClaveConductor;
    }

    public Label getLblTotalDeducciones1() {
        return lblTotalDeducciones1;
    }

    public void setLblTotalDeducciones1(Label lblTotalDeducciones1) {
        this.lblTotalDeducciones1 = lblTotalDeducciones1;
    }

    public Label getLblTotalDeducciones2() {
        return lblTotalDeducciones2;
    }

    public void setLblTotalDeducciones2(Label lblTotalDeducciones2) {
        this.lblTotalDeducciones2 = lblTotalDeducciones2;
    }

    public Label getLblTotalPercepciones1() {
        return lblTotalPercepciones1;
    }

    public void setLblTotalPercepciones1(Label lblTotalPercepciones1) {
        this.lblTotalPercepciones1 = lblTotalPercepciones1;
    }

    public Label getLblTotalPercepciones2() {
        return lblTotalPercepciones2;
    }

    public void setLblTotalPercepciones2(Label lblTotalPercepciones2) {
        this.lblTotalPercepciones2 = lblTotalPercepciones2;
    }

    public MyListbox getPercepcionesList() {
        return percepcionesList;
    }

    public void setPercepcionesList(MyListbox percepcionesList) {
        this.percepcionesList = percepcionesList;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        lsTarjetaRecaudacion = (List<TarjetaRecaudacion>) Executions.getCurrent().getArg().get("lsTarjetaRecaudacion");

        super.doAfterCompose(comp);

        descripcionViajesList.setItemRenderer(new RenderDescripcionViajes());
        percepcionesList.setItemRenderer(new RenderPercepciones());
        deduccionesList.setItemRenderer(new RenderDeducciones());

        lblNombreClaveConductor.setValue("Nombre/Clave Conductor");
        lblTotalDeducciones1.setValue("$");
        lblTotalDeducciones2.setValue("$");
        lblTotalPercepciones1.setValue("$");
        lblTotalPercepciones2.setValue("$");
        lblNetoPagar.setValue("$");
    }

    public void onClick$btnConfirmaPago(Event ev) throws InterruptedException {
        Messagebox.show("Imprimindo recibo.", "VTABOL", Messagebox.OK, Messagebox.INFORMATION);
    }
}
