/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Plaza;
import com.rjconsultores.ventaboletos.entidad.TarifaMinima;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.service.MonedaService;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.service.PlazaService;
import com.rjconsultores.ventaboletos.service.TarifaMinimaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxParada;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextboxDecimal;
import java.util.Calendar;
import java.util.List;
import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;

/**
 *
 * @author rodrigo
 */
@Controller("editarTarifaMinimaController")
@Scope("prototype")
public class EditarTarifaMinimaController extends MyGenericForwardComposer {

    @Autowired
    private TarifaMinimaService tarifaMinimaService;
    @Autowired
    private MarcaService marcaService;
    @Autowired
    private ParadaService paradaService;
    @Autowired
    private ClaseServicioService claseServicioService;
    @Autowired
    private PlazaService plazaService;
    @Autowired
    private MonedaService monedaService;
    private List<Moneda> lsMoneda;
    private List<Marca> lsMarcas;
    private List<ClaseServicio> lsClaseServico;
    private List<Plaza> lsPlaza;
    private MyListbox tarifaMinimaList;
    private Combobox cmbMarca;
    private MyComboboxParada cmbOrigem;
    private MyComboboxParada cmbDestino;
    private Combobox cmbClaseServicio;
    private Combobox cmbMoneda;
    private Combobox cmbPlaza;
    private TarifaMinima tarifaMinima;
    private Button btnApagar;
    private MyTextboxDecimal txtImportancia;
    private static Logger log = Logger.getLogger(EditarTarifaMinimaController.class);

    public List<Moneda> getLsMoneda() {
        return lsMoneda;
    }

    public void setLsMoneda(List<Moneda> lsMoneda) {
        this.lsMoneda = lsMoneda;
    }

    public List<Plaza> getLsPlaza() {
        return lsPlaza;
    }

    public void setLsPlaza(List<Plaza> lsPlaza) {
        this.lsPlaza = lsPlaza;
    }

    public Combobox getCmbClaseServicio() {
        return cmbClaseServicio;
    }

    public void setCmbClaseServicio(Combobox cmbClaseServicio) {
        this.cmbClaseServicio = cmbClaseServicio;
    }

    public Combobox getCmbMarca() {
        return cmbMarca;
    }

    public void setCmbMarca(Combobox cmbMarca) {
        this.cmbMarca = cmbMarca;
    }

    public Combobox getCmbOrigem() {
        return cmbOrigem;
    }

    public MyComboboxParada getCmbDestino() {
        return cmbDestino;
    }

    public void setCmbDestino(MyComboboxParada cmbDestino) {
        this.cmbDestino = cmbDestino;
    }

    public void setCmbOrigem(MyComboboxParada cmbOrigem) {
        this.cmbOrigem = cmbOrigem;
    }

    public List<ClaseServicio> getLsClaseServico() {
        return lsClaseServico;
    }

    public void setLsClaseServico(List<ClaseServicio> lsClaseServico) {
        this.lsClaseServico = lsClaseServico;
    }

    public List<Marca> getLsMarcas() {
        return lsMarcas;
    }

    public void setLsMarcas(List<Marca> lsMarcas) {
        this.lsMarcas = lsMarcas;
    }

    public TarifaMinima getTarifaMinima() {
        return tarifaMinima;
    }

    public void setTarifaMinima(TarifaMinima tarifaMinima) {
        this.tarifaMinima = tarifaMinima;
    }

    public Button getBtnApagar() {
        return btnApagar;
    }

    public void setBtnApagar(Button btnApagar) {
        this.btnApagar = btnApagar;
    }

    public Combobox getCmbMoneda() {
        return cmbMoneda;
    }

    public void setCmbMoneda(Combobox cmbMoneda) {
        this.cmbMoneda = cmbMoneda;
    }

    public Combobox getCmbPlaza() {
        return cmbPlaza;
    }

    public void setCmbPlaza(Combobox cmbPlaza) {
        this.cmbPlaza = cmbPlaza;
    }

    public MyListbox getTarifaMinimaList() {
        return tarifaMinimaList;
    }

    public void setTarifaMinimaList(MyListbox tarifaMinimaList) {
        this.tarifaMinimaList = tarifaMinimaList;
    }

    public TarifaMinimaService getTarifaMinimaService() {
        return tarifaMinimaService;
    }

    public void setTarifaMinimaService(TarifaMinimaService tarifaMinimaService) {
        this.tarifaMinimaService = tarifaMinimaService;
    }

    public MyTextboxDecimal getTxtImportancia() {
        return txtImportancia;
    }

    public void setTxtImportancia(MyTextboxDecimal txtImportancia) {
        this.txtImportancia = txtImportancia;
    }

    @Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tarifaMinima = (TarifaMinima) Executions.getCurrent().getArg().get("tarifaMinima");
        tarifaMinimaList = (MyListbox) Executions.getCurrent().getArg().get("tarifaMinimaList");

        lsMoneda = monedaService.obtenerTodos();
        lsMarcas = marcaService.obtenerTodos();
        lsClaseServico = claseServicioService.obtenerTodos();
        lsPlaza = plazaService.obtenerTodos();

        if (tarifaMinima.getTarifaminimaId() == null) {
            btnApagar.setVisible(Boolean.FALSE);
        }
        txtImportancia.focus();
    }

    public void onClick$btnSalvar(Event ev) throws InterruptedException {

        txtImportancia.getValue();
        cmbMoneda.getValue();
        cmbPlaza.getValue();
        cmbMarca.getValue();
        cmbOrigem.getValue(true);
        cmbDestino.getValue(true);
        cmbClaseServicio.getValue();

        tarifaMinima.setFecmodif(Calendar.getInstance().getTime());
        tarifaMinima.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        tarifaMinima.setActivo(Boolean.TRUE);

        try {
            if (tarifaMinima.getMoneda() == null) {
                Messagebox.show(
                        Labels.getLabel("editarTarifaMinimaController.btnFechar.MSG.moneda"),
                        Labels.getLabel("editarTarifaMinimaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else if (tarifaMinima.getPlaza() == null) {
                Messagebox.show(
                        Labels.getLabel("editarTarifaMinimaController.btnFechar.MSG.plaza"),
                        Labels.getLabel("editarTarifaMinimaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else if (tarifaMinima.getMarca() == null) {
                Messagebox.show(
                        Labels.getLabel("editarTarifaMinimaController.btnFechar.MSG.marca"),
                        Labels.getLabel("editarTarifaMinimaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else if (tarifaMinima.getOrigem() == null) {
                Messagebox.show(
                        Labels.getLabel("editarTarifaMinimaController.btnFechar.MSG.origen"),
                        Labels.getLabel("editarTarifaMinimaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else if (tarifaMinima.getDestino() == null) {
                Messagebox.show(
                        Labels.getLabel("editarTarifaMinimaController.btnFechar.MSG.destino"),
                        Labels.getLabel("editarTarifaMinimaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else if (tarifaMinima.getClaseServicio() == null) {
                Messagebox.show(
                        Labels.getLabel("editarTarifaMinimaController.btnFechar.MSG.tipo"),
                        Labels.getLabel("editarTarifaMinimaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);
            } else if (tarifaMinima.getOrigem().getParadaId().equals(tarifaMinima.getDestino().getParadaId())
                    && (!tarifaMinima.getOrigem().getParadaId().equals(-1) && !tarifaMinima.getDestino().getParadaId().equals(-1))) {
                Messagebox.show(
                        Labels.getLabel("MSG.Origem.Igual.Destino"),
                        Labels.getLabel("editarTarifaMinimaController.window.title"),
                        Messagebox.OK, Messagebox.EXCLAMATION);

            } else {
                if (tarifaMinima.getTarifaminimaId() == null) {
                    List<TarifaMinima> lsTM = tarifaMinimaService.pesquisar(txtImportancia.getValueDecimal(),
                            tarifaMinima.getMoneda(), tarifaMinima.getPlaza(), tarifaMinima.getMarca(),
                            tarifaMinima.getOrigem(), tarifaMinima.getDestino(), tarifaMinima.getClaseServicio());

                    if (lsTM.isEmpty()) {
                        tarifaMinimaService.suscribir(tarifaMinima);
                        tarifaMinimaList.addItem(tarifaMinima);

                        Messagebox.show(
                                Labels.getLabel("editarTarifaMinimaController.btnFechar.MSG.SuscbrirOK"),
                                Labels.getLabel("editarTarifaMinimaController.window.title"),
                                Messagebox.OK, Messagebox.INFORMATION);

                        closeWindow();
                    } else {
                        Messagebox.show(
                                Labels.getLabel("MSG.Registro.Existe"),
                                Labels.getLabel("editarTarifaMinimaController.window.title"),
                                Messagebox.OK, Messagebox.EXCLAMATION);
                    }
                } else {
                    tarifaMinimaService.actualizacion(tarifaMinima);
                    tarifaMinimaList.updateItem(tarifaMinima);

                    Messagebox.show(
                            Labels.getLabel("editarTarifaMinimaController.btnFechar.MSG.SuscbrirOK"),
                            Labels.getLabel("editarTarifaMinimaController.window.title"),
                            Messagebox.OK, Messagebox.INFORMATION);

                    closeWindow();
                }
            }

        } catch (Exception ex) {
            log.error("Editar tarida minimas: " + ex);
            Messagebox.show(
                    Labels.getLabel("MSG.Error"),
                    Labels.getLabel("editarTarifaMinimaController.window.title"),
                    Messagebox.OK, Messagebox.ERROR);
        }

    }

    public void onClick$btnApagar(Event ev) {
        tarifaMinima.setFecmodif(Calendar.getInstance().getTime());
        tarifaMinima.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        tarifaMinima.setActivo(Boolean.FALSE);

        try {
            int opcao = Messagebox.show(
                    Labels.getLabel("editarTarifaMinimaController.btnFechar.MSG.Deseja.Borrar"),
                    Labels.getLabel("editarTarifaMinimaController.window.title"),
                    Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

            if (opcao == Messagebox.YES) {
                tarifaMinimaService.borrar(tarifaMinima);
                tarifaMinimaList.removeItem(tarifaMinima);

                Messagebox.show(
                        Labels.getLabel("editarTarifaMinimaController.btnFechar.MSG.borrarOK"),
                        Labels.getLabel("editarTarifaMinimaController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);

                closeWindow();
            }
        } catch (Exception ex) {
            log.error(ex);
        }
    }
}
