package com.rjconsultores.ventaboletos.web.utilerias.render;

import org.zkoss.util.resource.Labels;
import org.zkoss.zul.Listcell;
import org.zkoss.zul.Listitem;
import org.zkoss.zul.ListitemRenderer;

import com.rjconsultores.ventaboletos.entidad.TipoEventoExtra;

public class RenderTipoEventoExtra implements ListitemRenderer {
	
	private String getTipo(int idTipo) {
		if (idTipo == 1) {
			return Labels.getLabel("editarTipoEventoExtraController.rd1.label");
		} else if (idTipo == 2) {
			return Labels.getLabel("editarTipoEventoExtraController.rd2.label");
		} else if (idTipo == 3) {
		    return Labels.getLabel("editarTipoEventoExtraController.rd3.label");
		}
		return "";
	}

	public void render(Listitem lstm, Object o) throws Exception {
		TipoEventoExtra banco = (TipoEventoExtra) o;

		Listcell lc = new Listcell(banco.getTipoeventoextraId().toString());
		lc.setParent(lstm);

		lc = new Listcell(banco.getDescTipoEvento() == null ? ""
				: banco.getDescTipoEvento());
		lc.setParent(lstm);
		
		String indTipo = null;
		
		if (banco.getIndoperacion() == null) {
			indTipo = "";
		} else {
			indTipo = getTipo(banco.getIndoperacion().intValue());
		}

		lc = new Listcell(indTipo);
		lc.setParent(lstm);
		
		

		lstm.setAttribute("data", banco);
	}

}
